package com.hzs.system.sys.mapper;

import java.util.List;

import com.hzs.common.domain.system.sys.SysMenu;
import org.apache.ibatis.annotations.Param;

/**
 * 菜单表 数据层
 *
 * @author hzs
 */
public interface SysMenuMapper {

    /**
     * 查询系统菜单列表
     *
     * @param menu 菜单信息
     * @return
     */
    List<SysMenu> selectMenuList(SysMenu menu);
    /**
     * @description: 导出查询所有菜单
     * @author: zhang jing
     * @date: 2023/7/27 13:59
     * @param: [menu]
     * @return: java.util.List<com.hzs.common.domain.system.sys.SysMenu>
     **/
    List<SysMenu> queryAllMenuAndColumn(SysMenu menu);


    /**
     * 根据用户查询系统菜单列表
     *
     * @param menu   菜单信息
     * @param userId
     * @return
     */
    List<SysMenu> selectMenuListByUserId(@Param("menu") SysMenu menu, @Param("userId") Long userId);

    /**
     * 根据用户ID查询按钮权限
     *
     * @param userId 用户ID
     * @return 权限列表
     */
    List<String> selectButtonPermsByUserId(Long userId);

    /**
     * 查询菜单
     *
     * @return 菜单列表
     */
    List<SysMenu> selectMenuTreeAll();

    /**
     * 查询全部菜单路由
     *
     * @return
     */
    List<SysMenu> selectMenuRoutersAll();

    /**
     * 根据用户ID查询菜单路由
     *
     * @param userId 用户ID
     * @return 菜单列表
     */
    List<SysMenu> selectMenuRoutersByUserId(Long userId);

    /**
     * 根据菜单ID查询信息
     *
     * @param menuId 菜单ID
     * @return 菜单信息
     */
    SysMenu selectMenuById(Long menuId);

    /**
     * 是否存在菜单子节点
     *
     * @param menuId 菜单ID
     * @return 结果
     */
    int hasChildByMenuId(Long menuId);

    /**
     * 新增菜单信息
     *
     * @param menu 菜单信息
     * @return 结果
     */
    int insertMenu(SysMenu menu);

    /**
     * 修改菜单信息
     *
     * @param menu 菜单信息
     * @return 结果
     */
    int updateMenu(SysMenu menu);

    /**
     * 删除菜单管理信息
     *
     * @param menuId 菜单ID
     * @param userId
     * @return
     */
    int deleteMenuById(@Param("menuId") Long menuId, @Param("userId") Long userId);

    /**
     * 校验菜单名称是否唯一
     *
     * @param menuName 菜单名称
     * @param parentId 父菜单ID
     * @return 结果
     */
    SysMenu checkMenuNameUnique(@Param("menuName") String menuName, @Param("parentId") Long parentId);

    /**
     * 校验菜单权限是否唯一
     *
     * @param perms 权限标识
     * @return
     */
    SysMenu checkMenuPermsUnique(@Param("perms") String perms);

    /**
     * 查询菜单+菜单列
     *
     * @param roleId 角色ID
     * @return
     */
    List<SysMenu> queryMenuAndColumn(@Param("roleId") Long roleId);

}
